<?php
declare(strict_types=1);

namespace Inti\Wp\Plugin\Core;

use Inti\Wp\Plugin\PluginInterface;
use function add_action;
use function wp_dequeue_script;
use function wp_dequeue_style;

/**
 * Class Assets
 *
 * @package Inti\Wp\Plugin\Core
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class Assets implements PluginInterface
{
    private array $dequeue;

    public function __construct(array $dequeue)
    {
        $this->dequeue = $dequeue;
    }

    public function attach(): void
    {
        add_action('wp_enqueue_scripts', [$this, 'wp_enqueue_scripts'], PHP_INT_MAX);
    }

    public function wp_enqueue_scripts()
    {
        foreach ($this->dequeue['scripts'] as $handle) {
            wp_dequeue_script($handle);
        }

        foreach ($this->dequeue['styles'] as $handle) {
            wp_dequeue_style($handle);
        }
    }
}
